import java.awt.*;
import java.awt.image.*;
import java.net.*;

/**
 * 摜c[
 */
public class ImageTool {
  /**
   * C[W擾܂
   * @param fileName 摜t@C
   * @param imageFilter C[WtB^[
   * @param component R|[lg
   */
  public static Image loadImage(
    String fileName,
    ImageFilter imageFilter,
    Component component) {
    // C[Wǂݍ݂܂
    Toolkit toolkit = Toolkit.getDefaultToolkit();
    Image srcImage = null;
    URL url = Global.getURL(fileName);
    if(url != null) {
      srcImage = toolkit.getImage(url);
    }
    if(srcImage == null) {
      return null;
    }

    MediaTracker mt = new MediaTracker(component);
    mt.addImage(srcImage, 0);
    try {
      mt.waitForID(0);
    } catch(Exception e) {}

    // ImageFilter pătB^[C[W쐬܂
    Image destImage = component.createImage(
      new FilteredImageSource(
      srcImage.getSource(), imageFilter));
      if(destImage == null) {
        return null;
    }

    mt.addImage(destImage, 1);
    try {
      mt.waitForID(1);
    } catch(Exception e) {}

    return destImage;
  }
 
  /**
   * C[W擾܂
   * @param fileName 摜t@C
   */
  public static Image loadImage(String fileName) {
    return loadImage(fileName, Global.m_maskFilter, Global.m_component);
  }

  /**
   * C[W擾܂
   * @param fileName 摜t@C
   * @param imageFilter C[WtB^[
   */
  public static Image loadImage(String fileName, MaskFilter imageFilter) {
    return loadImage(fileName, imageFilter, Global.m_component);
  }
}
