import java.awt.image.*;

/**
 * }XNpC[WtB^
 */
public class MaskFilter extends RGBImageFilter {
  // pbgihŔzw肵܂j
  protected int[][] m_palette;
  // }XNJ[iRGBj
  public int m_mask = 0xff00ff00;
  // xi0 ` 255j
  public int m_transparent = 0xffffffff;
  // Px[h
  public boolean m_brightMode = false;
  // Pxxi0 ` 255j
  public int m_bright = 0;

  /**
   * RXgN^
   */
  MaskFilter() {
    canFilterIndexColorModel = true;
  }

  /**
   * RXgN^
   * @param  mask  }XNliRGBj
   * @param  transparent  ߃xi0 ` 255j
   */
  public MaskFilter(int mask, int transparent) {
    canFilterIndexColorModel = true;
    m_mask = mask;
    m_transparent = (transparent << 24) | 0x00ffffff;
  }

  /**
   * sNZtB^[R[obN<br>
   * ڍׂ JDK ImageFilter NXQ
   * @param  x    sNZ X W
   * @param  y    sNZ Y W
   * @param  rgb    RGB l
   */
  public int filterRGB(int x, int y, int rgb) {
    // }XN`FbN
    if(rgb == m_mask) {
      return 0;
    }

    // pbgꍇ͖邳݂̂tB^O
    if(m_palette == null) {
      // Px[h̏ꍇ 1 sNZƂɋPxݒ肵܂
      if(m_brightMode == true) {
        int r = (((0x00ff0000 & rgb) >> 16) + m_bright);
        if(r > 256) {r = 255;}
        if(r < 0) {r = 0;}
        r &= 0x000000ff;
        int g = (((0x0000ff00 & rgb) >> 8) + m_bright);
        if(g > 256) {g = 255;}
        if(g < 0) {g = 0;}
        g &= 0x000000ff;
        int b = ((0x000000ff & rgb) + m_bright);
        if(b > 256) {b = 255;}
        if(b < 0) {b = 0;}
        b &= 0x000000ff;
        rgb = (rgb & 0xff000000) | ((r << 16) | (g << 8) | b);
      }
      // 邳lĔzF
      return (rgb & m_transparent);
    }

    // vpbgu܂
    int count = m_palette.length;
    for(int i = 0; i < count; i++) {
      if((m_palette[i][0] & 0x00ffffff) == (rgb & 0x00ffffff)) {
        rgb = m_palette[i][1];
        break;
      }
    }

    // Px[h̏ꍇ 1 sNZƂɋPxݒ肵܂
    if(m_brightMode == true) {
      int r = (((0x00ff0000 & rgb) >> 16) + m_bright);
      if(r > 256) {r = 255;}
      r &= 0x000000ff;
      int g = (((0x0000ff00 & rgb) >> 8) + m_bright);
      if(g > 256) {g = 255;}
      g &= 0x000000ff;
      int b = ((0x000000ff & rgb) + m_bright);
      if(b > 256) {b = 255;}
      b &= 0x000000ff;
      rgb = (rgb & 0x00ffffff) | ((r << 16) | (g << 8) | b);
    }
    // 邳lĔzF
    return (rgb & m_transparent);
  }
}
