import java.awt.event.*;

/**
 * Rg[[
 */
public class Controller {
  // Rg[
  public static final int UP      = 0x00000001;
  public static final int DOWN    = 0x00000002;
  public static final int LEFT    = 0x00000004;
  public static final int RIGHT   = 0x00000008;
  public static final int BUTTON1 = 0x00000010;
  public static final int BUTTON2 = 0x00000020;
  public static final int BUTTON3 = 0x00000040;
  public static final int START   = 0x10000000;
  public static final int SELECT  = 0x20000000;

  // L[
  public static int m_status = 0x00000000;

  /**
   * L[{[hCxg<br>
   * o[̃Q[lĂ̂ŁA㉺⍶EɉȂ悤ɍl܂
   * @param  e  L[Cxg
   */
  public static void processKeyEvent(KeyEvent e) {
    switch(e.getID()) {
      // L[_ECxg
      case KeyEvent.KEY_PRESSED:
        switch(e.getKeyCode()) {
          //----
          // L[
          //----
          case KeyEvent.VK_UP:
            if((Controller.m_status & Controller.UP) == 0) {
              Controller.m_status |= Controller.UP;
              Controller.m_status &= ~Controller.DOWN;
            }
            break;

          case KeyEvent.VK_DOWN:
            if((Controller.m_status & Controller.DOWN) == 0) {
              Controller.m_status |= Controller.DOWN;
              Controller.m_status &= ~Controller.UP;
            }
            break;

          case KeyEvent.VK_LEFT:
            if((Controller.m_status & Controller.LEFT) == 0) {
              Controller.m_status |= Controller.LEFT;
              Controller.m_status &= ~Controller.RIGHT;
            }
            break;

          case KeyEvent.VK_RIGHT:
            if((Controller.m_status & Controller.RIGHT) == 0) {
              Controller.m_status |= Controller.RIGHT;
              Controller.m_status &= ~Controller.LEFT;
            }
            break;

          // {^ 1
          case KeyEvent.VK_Z:
            if((Controller.m_status & Controller.BUTTON1) == 0) {
              Controller.m_status |= Controller.BUTTON1;
            }
            break;

          // {^ 2 
          case KeyEvent.VK_X:
            if((Controller.m_status & Controller.BUTTON2) == 0) {
              Controller.m_status |= Controller.BUTTON2;
            }
            break;

          // {^ 3
          case KeyEvent.VK_C:
            if((Controller.m_status & Controller.BUTTON3) == 0) {
              Controller.m_status |= Controller.BUTTON3;
            }
            break;

          // SELECT
          case KeyEvent.VK_W:
            if((Controller.m_status & Controller.SELECT) == 0) {
              Controller.m_status |= Controller.SELECT;
            }
            break;

          // START 
          case KeyEvent.VK_ENTER:
          case KeyEvent.VK_Q:
            if((Controller.m_status & Controller.START) == 0) {
              Controller.m_status |= Controller.START;
            }
            break;
        }
        break;

      // L[AbvCxg
      case KeyEvent.KEY_RELEASED:
        switch(e.getKeyCode()) {
          //----
          // L[
          //----
          case KeyEvent.VK_UP:
            Controller.m_status &= ~Controller.UP;
            break;

          case KeyEvent.VK_DOWN:
            Controller.m_status &= ~Controller.DOWN;
            break;

          case KeyEvent.VK_LEFT:
            Controller.m_status &= ~Controller.LEFT;
            break;

          case KeyEvent.VK_RIGHT:
            Controller.m_status &= ~Controller.RIGHT;
            break;

          // {^ 1
          case KeyEvent.VK_Z:
            Controller.m_status &= ~Controller.BUTTON1;
            break;

          // {^ 2
          case KeyEvent.VK_X:
            Controller.m_status &= ~Controller.BUTTON2;
            break;

          // {^ 3
          case KeyEvent.VK_C:
            Controller.m_status &= ~Controller.BUTTON3;
            break;

          // SELECT
          case KeyEvent.VK_W:
            Controller.m_status &= ~Controller.SELECT;
            break;

          // START
          case KeyEvent.VK_ENTER:
          case KeyEvent.VK_Q:
            Controller.m_status &= ~Controller.START;
            break;
        }
        break;
    }
  }
}
